import java.util.Random;
import com.pi4j.io.serial.Serial;
import com.pi4j.io.serial.SerialDataEvent;
import com.pi4j.io.serial.SerialDataListener;
import com.pi4j.io.serial.SerialFactory;
import java.lang.Object;

class HexAutomation extends Thread
{
    public static void main(String args[])
    {
        (new HexAutomation()).start();
    }

    final Serial serial = SerialFactory.createInstance();

    final Object sendLock = new Object();

    final double CRrFemurHornOffset1 = 0;
    final double CRmFemurHornOffset1 = 0;
    final double CRfFemurHornOffset1 = 0;
    final double CLrFemurHornOffset1 = 0;
    final double CLmFemurHornOffset1 = 0;
    final double CLfFemurHornOffset1 = 0;
    final double CPfConst = 592; //old 650 ; 900*(1000/cPwmDiv)+cPFConst must always be 1500
    final double CPwmDiv = 991; //old 1059;
    final double CTravelDeadZone = 1;
    final double C1Dec = 10;
    final double C2Dec = 100;
    final double C4Dec = 10000;
    final double C6Dec = 1000000;

    final int CLf = 5;
    final int CLm = 4;
    final int CLr = 3;
    final int CRf = 2;
    final int CRm = 1;
    final int CRr = 0;

    private final int CoxaMin = -700; //-650
    private final int CoxaMax = 700; //CoxaMax
    private final int FemurMin = -1050; //-1050
    private final int FemurMax = 350; //150
    private final int TibiaMin = -450; //-450
    private final int TibiaMax = 350; //350

    final double cRRCoxaMin1 = CoxaMin; //Mechanical limits of the Right Rear Leg
    final double cRRCoxaMax1 = CoxaMax;
    final double cRRFemurMin1 = FemurMin;
    final double cRRFemurMax1 = FemurMax;
    final double cRRTibiaMin1 = TibiaMin;
    final double cRRTibiaMax1 = TibiaMax;

    final double cRMCoxaMin1 = CoxaMin; //Mechanical limits of the Right Middle Leg
    final double cRMCoxaMax1 = CoxaMax;
    final double cRMFemurMin1 = FemurMin;
    final double cRMFemurMax1 = FemurMax;
    final double cRMTibiaMin1 = TibiaMin;
    final double cRMTibiaMax1 = TibiaMax;

    final double cRFCoxaMin1 = CoxaMin; //Mechanical limits of the Right Front Leg
    final double cRFCoxaMax1 = CoxaMax;
    final double cRFFemurMin1 = FemurMin;
    final double cRFFemurMax1 = FemurMax;
    final double cRFTibiaMin1 = TibiaMin;
    final double cRFTibiaMax1 = TibiaMax;

    final double cLRCoxaMin1 = CoxaMin; //Mechanical limits of the Left Rear Leg
    final double cLRCoxaMax1 = CoxaMax;
    final double cLRFemurMin1 = FemurMin;
    final double cLRFemurMax1 = FemurMax;
    final double cLRTibiaMin1 = TibiaMin;
    final double cLRTibiaMax1 = TibiaMax;

    final double cLMCoxaMin1 = CoxaMin; //Mechanical limits of the Left Middle Leg
    final double cLMCoxaMax1 = CoxaMax;
    final double cLMFemurMin1 = FemurMin;
    final double cLMFemurMax1 = FemurMax;
    final double cLMTibiaMin1 = TibiaMin;
    final double cLMTibiaMax1 = TibiaMax;

    final double cLFCoxaMin1 = CoxaMin; //Mechanical limits of the Left Front Leg
    final double cLFCoxaMax1 = CoxaMax;
    final double cLFFemurMin1 = FemurMin;
    final double cLFFemurMax1 = FemurMax;
    final double cLFTibiaMin1 = TibiaMin;
    final double cLFTibiaMax1 = TibiaMax;

    final double cRRCoxaAngle1 = -450;
    final double cRMCoxaAngle1 = 0;
    final double cRFCoxaAngle1 = 450;
    final double cLRCoxaAngle1 = -450;
    final double cLMCoxaAngle1 = 0;
    final double cLFCoxaAngle1 = 450;

    final double cRFOffsetX = -70;
    final double cRFOffsetZ = -120;

    final double cLFOffsetZ = -120;
    final double cLFOffsetX = 70;

    final double cRROffsetZ = 120;
    final double cRROffsetX = -70;

    final double cLROffsetZ = 120;
    final double cLROffsetX = 70;

    final double cRMOffsetX = -140;
    final double cRMOffsetZ = 0;

    final double cLMOffsetX = 140;
    final double cLMOffsetZ = 0;

    final double CoxaLength = 30;
    final double FemurLength = 60;
    final double TibiaLength = 65;

    final double cRRCoxaLength = CoxaLength;
    final double cRMCoxaLength = CoxaLength;
    final double cRFCoxaLength = CoxaLength;
    final double cLRCoxaLength = CoxaLength;
    final double cLMCoxaLength = CoxaLength;
    final double cLFCoxaLength = CoxaLength;
    final double cRRFemurLength = FemurLength;
    final double cRMFemurLength = FemurLength;
    final double cRFFemurLength = FemurLength;
    final double cLRFemurLength = FemurLength;
    final double cLMFemurLength = FemurLength;
    final double cLFFemurLength = FemurLength;
    final double cLFTibiaLength = TibiaLength;
    final double cLMTibiaLength = TibiaLength;
    final double cLRTibiaLength = TibiaLength;
    final double cRFTibiaLength = TibiaLength;
    final double cRMTibiaLength = TibiaLength;
    final double cRRTibiaLength = TibiaLength;

    final double CHexInitXz = 105;
    final double CHexInitXzCos45 = 74; // COS(45) = .7071
    final double CHexInitXzSin45 = 74; // sin(45) = .7071
    final double CHexInitY = 26;

    final double CRfInitPosX = CHexInitXzCos45;
    final double CRfInitPosY = CHexInitY;
    final double CRfInitPosZ = -CHexInitXzSin45;

    final double CLrInitPosX = CHexInitXzCos45;
    final double CLrInitPosY = CHexInitY;
    final double CLrInitPosZ = CHexInitXzCos45;

    final double CLmInitPosX = CHexInitXz;
    final double CLmInitPosY = CHexInitY;
    final double CLmInitPosZ = 0;

    final double CLfInitPosX = CHexInitXzCos45;
    final double CLfInitPosY = CHexInitY;
    final double CLfInitPosZ = -CHexInitXzSin45;

    final double CRmInitPosX = CHexInitXz;
    final double CRmInitPosY = CHexInitY;
    final double CRmInitPosZ = 0;

    final double CRrInitPosX = CHexInitXzCos45;
    final double CRrInitPosY = CHexInitY;
    final double CRrInitPosZ = CHexInitXzSin45;

    final double _cCoxaAngle1[] =
            {
                    cRRCoxaAngle1, cRMCoxaAngle1, cRFCoxaAngle1, cLRCoxaAngle1, cLMCoxaAngle1, cLFCoxaAngle1
            };

    //Leg Lengths
    final double _cCoxaLength[] =
            {
                    cRRCoxaLength, cRMCoxaLength, cRFCoxaLength, cLRCoxaLength, cLMCoxaLength, cLFCoxaLength
            };

    final double _cCoxaMax1[] =
            {
                    cRRCoxaMax1, cRMCoxaMax1, cRFCoxaMax1, cLRCoxaMax1, cLMCoxaMax1, cLFCoxaMax1
            };

    final double _cCoxaMin1[] =
            {
                    cRRCoxaMin1, cRMCoxaMin1, cRFCoxaMin1, cLRCoxaMin1, cLMCoxaMin1, cLFCoxaMin1
            };

    final double _cFemurHornOffset1[] =
            {
                    CRrFemurHornOffset1, CRmFemurHornOffset1, CRfFemurHornOffset1, CLrFemurHornOffset1, CLmFemurHornOffset1, CLfFemurHornOffset1
            };

    final double _cFemurLength[] =
            {
                    cRRFemurLength, cRMFemurLength, cRFFemurLength, cLRFemurLength, cLMFemurLength, cLFFemurLength
            };

    final double _cFemurMax1[] =
            {
                    cRRFemurMax1, cRMFemurMax1, cRFFemurMax1, cLRFemurMax1, cLMFemurMax1, cLFFemurMax1
            };

    final double _cFemurMin1[] =
            {
                    cRRFemurMin1, cRMFemurMin1, cRFFemurMin1, cLRFemurMin1, cLMFemurMin1, cLFFemurMin1
            };

    //Start positions for the leg
    double _cInitPosX[] = {CRrInitPosX, CRmInitPosX, CRfInitPosX, CLrInitPosX, CLmInitPosX, CLfInitPosX};
    double _cInitPosY[] = {CRrInitPosY, CRmInitPosY, CRfInitPosY, CLrInitPosY, CLmInitPosY, CLfInitPosY};
    double _cInitPosZ[] = {CRrInitPosZ, CRmInitPosZ, CRfInitPosZ, CLrInitPosZ, CLmInitPosZ, CLfInitPosZ};

    double _cOffsetX[] = {cRROffsetX, cRMOffsetX, cRFOffsetX, cLROffsetX, cLMOffsetX, cLFOffsetX};
    double _cOffsetZ[] = {cRROffsetZ, cRMOffsetZ, cRFOffsetZ, cLROffsetZ, cLMOffsetZ, cLFOffsetZ};

    double _coxaAngle1[] = {0,0,0,0,0,0};

    double _cTibiaLength[] =
            {
                    cRRTibiaLength, cRMTibiaLength, cRFTibiaLength, cLRTibiaLength, cLMTibiaLength, cLFTibiaLength
            };

    double _cTibiaMax1[] =
            {
                    cRRTibiaMax1, cRMTibiaMax1, cRFTibiaMax1, cLRTibiaMax1, cLMTibiaMax1, cLFTibiaMax1
            };

    double _cTibiaMin1[] =
            {
                    cRRTibiaMin1, cRMTibiaMin1, cRFTibiaMin1, cLRTibiaMin1, cLMTibiaMin1, cLFTibiaMin1
            };

    double _femurAngle1[] = new double[6]; //Actual Angle of the vertical hip, decimals = 1
    int _gaitLegNr[] = {0, 0, 0, 0 ,0, 0}; //Init position of the leg
    double _gaitPosX[] = {0, 0, 0, 0 ,0, 0}; //Array containing Relative X position corresponding to the Gait
    double _gaitPosY[] = {0, 0, 0, 0 ,0, 0}; //Array containing Relative Y position corresponding to the Gait
    double _gaitPosZ[] = {0, 0, 0, 0 ,0, 0}; //Array containing Relative Z position corresponding to the Gait
    double _gaitRotY[] = {0, 0, 0, 0 ,0, 0}; //Array containing Relative Y rotation corresponding to the Gait

    //ArcCosinus Table
    //Table build in to 3 part to get higher accuracy near cos = 1.
    //The biggest error is near cos = 1 and has a biggest value of 3*0.012098rad = 0.521 deg.
    //-    Cos 0 to 0.9 is done by steps of 0.0079 rad. [1/127]
    //-    Cos 0.9 to 0.99 is done by steps of 0.0008 rad [0.1/127]
    //-    Cos 0.99 to 1 is done by step of 0.0002 rad [0.01/64]
    //Since the tables are overlapping the full range of 127+127+64 is not necessary. Total bytes: 277
    final double _getACos[] =
            {
                    255, 254, 252, 251, 250, 249, 247, 246, 245, 243, 242, 241, 240, 238, 237, 236, 234, 233, 232, 231, 229, 228, 227, 225,
                    224, 223, 221, 220, 219, 217, 216, 215, 214, 212, 211, 210, 208, 207, 206, 204, 203, 201, 200, 199, 197, 196, 195, 193,
                    192, 190, 189, 188, 186, 185, 183, 182, 181, 179, 178, 176, 175, 173, 172, 170, 169, 167, 166, 164, 163, 161, 160, 158,
                    157, 155, 154, 152, 150, 149, 147, 146, 144, 142, 141, 139, 137, 135, 134, 132, 130, 128, 127, 125, 123, 121, 119, 117,
                    115, 113, 111, 109, 107, 105, 103, 101, 98, 96, 94, 92, 89, 87, 84, 81, 79, 76, 73, 73, 73, 72, 72, 72, 71, 71, 71, 70, 70,
                    70, 70, 69, 69, 69, 68, 68, 68, 67, 67, 67, 66, 66, 66, 65, 65, 65, 64, 64, 64, 63, 63, 63, 62, 62, 62, 61, 61, 61, 60, 60, 59,
                    59, 59, 58, 58, 58, 57, 57, 57, 56, 56, 55, 55, 55, 54, 54, 53, 53, 53, 52, 52, 51, 51, 51, 50, 50, 49, 49, 48, 48, 47, 47, 47,
                    46, 46, 45, 45, 44, 44, 43, 43, 42, 42, 41, 41, 40, 40, 39, 39, 38, 37, 37, 36, 36, 35, 34, 34, 33, 33, 32, 31, 31, 30, 29, 28,
                    28, 27, 26, 25, 24, 23, 23, 23, 23, 22, 22, 22, 22, 21, 21, 21, 21, 20, 20, 20, 19, 19, 19, 19, 18, 18, 18, 17, 17, 17, 17, 16,
                    16, 16, 15, 15, 15, 14, 14, 13, 13, 13, 12, 12, 11, 11, 10, 10, 9, 9, 8, 7, 6, 6, 5, 3, 0
            };

    double _legPosX[] = {0, 0, 0, 0 ,0, 0}; //Actual X Position of the Leg should be length of 6
    double _legPosY[] = {0, 0, 0, 0 ,0, 0}; //Actual Y Position of the Leg
    double _legPosZ[] = {0, 0, 0, 0 ,0, 0}; //Actual Z Position of the Leg
    double _tibiaAngle1[] = {0, 0, 0, 0 ,0, 0}; //Actual Angle of the knee, decimals = 1

    double BodyPosX; //Global Input for the position of the body
    double BodyPosY;
    double BodyPosZ;
    double BodyRotOffsetX; //Input X offset value to adjust center pofloat of rotation
    double BodyRotOffsetY; //Input Y offset value to adjust center pofloat of rotation
    double BodyRotOffsetZ; //Input Z offset value to adjust center pofloat of rotation
    double BodyRotX1; //Global Input pitch of the body
    double BodyRotY1; //Global Input rotation of the body
    double BodyRotZ1; //Global Input roll of the body

    double _gaitStep;
    int GaitType;
    double _halfLiftHeight; //If TRUE the outer positions of the lifted legs will be half height
    double _ikSolution; //Output true if the solution is possible
    double _ikSolutionError; //Output true if the solution is NOT possible
    double _ikSolutionWarning; //Output true if the solution is NEARLY possible

    int _lastLeg; //TRUE when the current leg is the last leg of the sequence

    int LegLiftHeight; //Current Travel height
    int _liftDivFactor; //Normally: 2, when NrLiftedPos=5: 4
    int _nomGaitSpeed; //Nominal speed of the gait
    int _nrLiftedPos; //Number of positions that a single leg is lifted [1-3]

    int _stepsInGait; //Number of steps in gait
    double _tlDivFactor; //Number of steps that a leg is on the floor while walking

    double TravelLengthX; //Current Travel length X
    double TravelLengthZ; //Current Travel length Z
    Boolean _travelRequest; //Temp to check if the gait is in motion
    double TravelRotationY; //Current Travel Rotation Y

    int Center;
    int Right;
    int Left;
    int FarRight;
    int FarLeft;
    int RearLeft;
    int RearRight;
    int Rear;
    double Yaw;
    double Pitch;
    double Roll;
    double Heading;

    int _avoidCount;
    double Latitude;
    double Longitude;
    double LatitudeDegrees;
    double LongitudeDegrees;
    double Speed;
    double Angle;
    double PitchLevel = 0;

    int Disabled;

    int _safeZone = 15; //when this is reached, avoidance starts

    void Send(String toSend)
    {
        synchronized (sendLock)
        {
            serial.writeln(toSend);
        }
    }

    void ResetServos()
    {
        for (int i = 0; i < 32; i++)
        {
            Send("#" + i +"P0S700");
        }
    }

    Random _random = new Random();

    Boolean WarningCenter()
    {
        return Center < _safeZone;
    }

    Boolean WarningRight()
    {
        return Right < _safeZone;
    }

    Boolean WarningLeft()
    {
        return Left < _safeZone;
    }

    Boolean WarningFarRight()
    {
        return FarRight < _safeZone;
    }

    Boolean WarningFarLeft()
    {
        return FarLeft < _safeZone;
    }

    Boolean _reverseAvoid;

    void Navigate()
    {
        if (!WarningCenter() && !WarningLeft() && !WarningRight())
        {
            _reverseAvoid = false;
            System.out.println("Forward");

            TravelLengthZ = -(Map(Center, 10, 120, 15, 70) + 20);

            TravelLengthX = 0;
            TravelRotationY = 0;
        }
        else if (WarningCenter() || (WarningLeft() && WarningRight()))
        {
            _reverseAvoid = true;
            System.out.println("Reverse");

            TravelLengthZ = Map(Center, 10, 312, 15, 90) + 20;

            TravelLengthX = 0;
            TravelRotationY = 0;
        }
        else if (WarningLeft() && !WarningRight())
        {
            _reverseAvoid = false;
            System.out.println("Turn right");

            TravelLengthX = 10;
            TravelRotationY = 1;
        }
        else if (WarningRight() && !WarningLeft())
        {
            _reverseAvoid = false;

            System.out.println("Turn left");

            TravelLengthX = -10;
            TravelRotationY = -1;
        }

        if (WarningFarLeft())
        {
            _reverseAvoid = false;
            System.out.println("Slide right");

            TravelLengthX = Map(Center, 5, 100, 15, 60);
        }
        else if (WarningFarRight())
        {
            _reverseAvoid = false;
            System.out.println("Slide left");

            TravelLengthX = -Map(Center, 5, 100, 15, 60);
        }

    }

    //TODD! Your GPS stuff would go here.
    void FindRoute()
    {

    }

    void Stop()
    {
        TravelRotationY = 0;
        TravelLengthZ = 0;
        TravelLengthX = 0;
    }

    public void run()
    {
        Thread.currentThread().setPriority(Thread.MAX_PRIORITY);

        serial.open("//dev//ttyAMA0", 57600);

        serial.addListener(new SerialDataListener() {
            @Override
            public void dataReceived(SerialDataEvent event)
            {
                try
                {
                    int s = event.getData().indexOf('~') + 1;
                    int e = event.getData().indexOf('!') - 1;

                    if (e < s || event.getData().length() < 36)
                        return;

                    String r = event.getData().substring(s,e);

                    System.out.println(r);

                    String[] split = r.split("\\|");

                    Center = Integer.parseInt(split[0]);
                    Right = Integer.parseInt(split[1]);
                    Left = Integer.parseInt(split[2]);
                    FarRight = Integer.parseInt(split[3]);
                    FarLeft = Integer.parseInt(split[4]);
                    RearLeft = Integer.parseInt(split[5]);
                    RearRight = Integer.parseInt(split[6]);
                    Rear = Integer.parseInt(split[7]);
                    Yaw = Double.parseDouble(split[8]);
                    Pitch = Double.parseDouble(split[9]);
                    Roll = Double.parseDouble(split[10]);
                    Heading = Double.parseDouble(split[11]);
                    Disabled = Integer.parseInt(split[12]);
                    Latitude = Double.parseDouble(split[13]);
                    Longitude = Double.parseDouble(split[14]);
                    LatitudeDegrees = Double.parseDouble(split[15]);
                    LongitudeDegrees = Double.parseDouble(split[16]);
                    Speed = Double.parseDouble(split[17]);
                    Angle = Double.parseDouble(split[18]);
                }
                catch (Exception exc)
                {
                    System.out.println("Exception getting serial data");
                }
            }
        });

        ResetServos();

        Disabled = 1;

        LegLiftHeight = 20;
        BodyPosY = 80;

        GaitType = 1;

        GaitSelect();

        for (int _legIndex = 0; _legIndex <= 5; _legIndex++)
        {
            _legPosX[_legIndex] = (_cInitPosX[_legIndex]); //Set start positions for each leg
            _legPosY[_legIndex] = (_cInitPosY[_legIndex]);
            _legPosZ[_legIndex] = (_cInitPosZ[_legIndex]);
        }

        while (true)
        {
            if (Disabled == 1)
            {
                ResetServos();
                continue;
            }

            if (!_reverseAvoid || _avoidCount > 80)
            {
                _avoidCount = 0;
                Navigate();
            }
            else
            {
                _avoidCount++;

                if (!WarningLeft())
                {
                    TravelLengthX = -10;
                    TravelRotationY = -1;
                }
                else if (!WarningRight())
                {
                    TravelLengthX = 10;
                    TravelRotationY = 1;
                }
            }

            //Gait
            GaitSeq();

            _ikSolution = 0;
            _ikSolutionError = 0;
            _ikSolutionWarning = 0;

            double rb[] = new double[3]; // 0 x, 1 z, 2 y

            //Do IK for all Right legs
            for (int _legIndex = 0; _legIndex <= 2; _legIndex++)
            {
                rb = BodyFk(-_legPosX[_legIndex] + BodyPosX + _gaitPosX[_legIndex],
                        _legPosZ[_legIndex] + BodyPosZ + _gaitPosZ[_legIndex],
                        _legPosY[_legIndex] + BodyPosY + _gaitPosY[_legIndex],
                        _gaitRotY[_legIndex], _legIndex);

                LegIK(_legPosX[_legIndex] - BodyPosX + rb[0] - (_gaitPosX[_legIndex]),
                        _legPosY[_legIndex] + BodyPosY - rb[2] + _gaitPosY[_legIndex],
                        _legPosZ[_legIndex] + BodyPosZ - rb[1] + _gaitPosZ[_legIndex],
                        _legIndex);
            }

            //Do IK for all Left legs
            for (int _legIndex = 3; _legIndex <= 5; _legIndex++)
            {
                BodyFk(_legPosX[_legIndex] - BodyPosX + _gaitPosX[_legIndex],
                        _legPosZ[_legIndex] + BodyPosZ + _gaitPosZ[_legIndex],
                        _legPosY[_legIndex] + BodyPosY + _gaitPosY[_legIndex],
                        _gaitRotY[_legIndex], _legIndex);
                LegIK(_legPosX[_legIndex] + BodyPosX - rb[0] + _gaitPosX[_legIndex],
                        _legPosY[_legIndex] + BodyPosY - rb[2] + _gaitPosY[_legIndex],
                        _legPosZ[_legIndex] + BodyPosZ - rb[1] + _gaitPosZ[_legIndex],
                        _legIndex);
            }

            if (_ikSolutionError == 1 || _ikSolution == 0)
            {
                //System.out.println("No solution found ----------------------------------------------");
                continue;
            }

            CheckAngles();

            try
            {
                Thread.sleep(_nomGaitSpeed - 5);
            }
            catch (InterruptedException e)
            {
            }

            UpdateServoDriver();
        }
    }

    void Balance()
    {
        //if (_sensor.Roll > RollLevel + .8)
        //{
        //    BodyRotZ1 = -(Map(_sensor.Roll, 0, 8, 0, 18));
        //}
        //else if (_sensor.Roll < -(RollLevel - .8))
        //{
        //    BodyRotZ1 = -(Map(_sensor.Roll, 0, 8, 0, 18));
        //}
        //else
        //    BodyRotZ1 = 0;

        if (Pitch > (PitchLevel + .8))
        {
            BodyRotX1 = Math.round((Map(Pitch, PitchLevel, 8, 0, 8)));
        }
        else if (Pitch < -(PitchLevel - .8))
        {
            BodyRotX1 = -Math.abs(Math.round((Map(Pitch, PitchLevel, 8, 0, 8))));
        }
        else
            BodyRotX1 = 0;
    }

    private double[] BodyFk(double posX, double posZ, double posY, double RotationY, int BodyIKLeg)
    {
        double r[] = new double[3];

        double sinA4; //Sin buffer for BodyRotX calculations
        double cosA4; //Cos buffer for BodyRotX calculations
        double sinB4; //Sin buffer for BodyRotX calculations
        double cosB4; //Cos buffer for BodyRotX calculations
        double sinG4; //Sin buffer for BodyRotZ calculations
        double cosG4; //Cos buffer for BodyRotZ calculations

        //Calculating totals from center of the body to the feet
        double cprX = (_cOffsetX[BodyIKLeg]) + posX + BodyRotOffsetX;
        double cprY = posY + BodyRotOffsetY;
        double cprZ = (_cOffsetZ[BodyIKLeg]) + posZ + BodyRotOffsetZ;

        //Successive global rotation matrix:
        //Math shorts for rotation: Alfa [A] = Xrotate, Beta [B] = Zrotate, Gamma [G] = Yrotate
        //Sinus Alfa = SinA, cosinus Alfa = cosA. and so on...

        //First calculate sinus and cosinus for each rotation:
        double g4[] = GetSinCos(BodyRotX1);
        sinG4 = g4[0];
        cosG4 = g4[1];

        double b4[] = GetSinCos(BodyRotZ1);
        sinB4 = b4[0];
        cosB4 = b4[1];

        double a4[] = GetSinCos(BodyRotY1 + (RotationY * C1Dec));
        sinA4 = a4[0];
        cosA4 = a4[1];

        //Calculation of rotation matrix:
        //_bodyFkPosX = (cprX*C2Dec - ((cprX*C2Dec*cosA4/C4Dec*cosB4/C4Dec) - (cprZ*C2Dec*cosB4/C4Dec*sinA4/C4Dec) + (cprY*C2Dec*sinB4/C4Dec)))/C2Dec;
        //_bodyFkPosZ = (cprZ*C2Dec - ((cprX*C2Dec*cosG4/C4Dec*sinA4/C4Dec) + (cprX*C2Dec*cosA4/C4Dec*sinB4/C4Dec*sinG4/C4Dec) + (cprZ*C2Dec*cosA4/C4Dec*cosG4/C4Dec) - (cprZ*C2Dec*sinA4/C4Dec*sinB4/C4Dec*sinG4/C4Dec) - (cprY*C2Dec*cosB4/C4Dec*sinG4/C4Dec)))/C2Dec;
        //_bodyFkPosY = (cprY*C2Dec - ((cprX*C2Dec*sinA4/C4Dec*sinG4/C4Dec) - (cprX*C2Dec*cosA4/C4Dec*cosG4/C4Dec*sinB4/C4Dec) + (cprZ*C2Dec*cosA4/C4Dec*sinG4/C4Dec) + (cprZ*C2Dec*cosG4/C4Dec*sinA4/C4Dec*sinB4/C4Dec) + (cprY*C2Dec*cosB4/C4Dec*cosG4/C4Dec)))/C2Dec;
        r[0] = (cprX*C2Dec - ((cprX*C2Dec*cosA4/C4Dec*cosB4/C4Dec) - (cprZ*C2Dec*cosB4/C4Dec*sinA4/C4Dec) + (cprY*C2Dec*sinB4/C4Dec)))/C2Dec;
        r[1] = (cprZ*C2Dec - ((cprX*C2Dec*cosG4/C4Dec*sinA4/C4Dec) + (cprX*C2Dec*cosA4/C4Dec*sinB4/C4Dec*sinG4/C4Dec) + (cprZ*C2Dec*cosA4/C4Dec*cosG4/C4Dec) - (cprZ*C2Dec*sinA4/C4Dec*sinB4/C4Dec*sinG4/C4Dec) - (cprY*C2Dec*cosB4/C4Dec*sinG4/C4Dec)))/C2Dec;
        r[2] = (cprY*C2Dec - ((cprX*C2Dec*sinA4/C4Dec*sinG4/C4Dec) - (cprX*C2Dec*cosA4/C4Dec*cosG4/C4Dec*sinB4/C4Dec) + (cprZ*C2Dec*cosA4/C4Dec*sinG4/C4Dec) + (cprZ*C2Dec*cosG4/C4Dec*sinA4/C4Dec*sinB4/C4Dec) + (cprY*C2Dec*cosB4/C4Dec*cosG4/C4Dec)))/C2Dec;

        return r;
    }

    private void LegIK(double IKFeetPosX, double IKFeetPosY, double IKFeetPosZ, int LegIKLegNr)
    {
        double IKSW2; //Length between Shoulder and Wrist, decimals = 2
        double IKA14; //Angle of the line S>W with respect to the ground in radians, decimals = 4
        double IKA24; //Angle of the line S>W with respect to the femur in radians, decimals = 4
        double IKFeetPosXZ; //Diagonal direction from Input X and Z

        double Temp1;
        double Temp2;
        double T3;

        //Calculate IKCoxaAngle and IKFeetPosXZ
        //float getatan = GetATan2(IKFeetPosX, IKFeetPosZ);
        double[] getatan = GetATan2(IKFeetPosX, IKFeetPosZ);
        _coxaAngle1[LegIKLegNr] = ((getatan[0] * 180) / 3141) + (_cCoxaAngle1[LegIKLegNr]);

        //Length between the Coxa and tars [foot]
        IKFeetPosXZ = getatan[1]/C2Dec;

        //Using GetAtan2 for solving IKA1 and IKSW
        //IKA14 - Angle between SW line and the ground in radians
        //IKA14 = GetATan2(IKFeetPosY - TarsOffsetY, IKFeetPosXZ - (cCoxaLength[LegIKLegNr]) - TarsOffsetXZ);
        getatan = GetATan2(IKFeetPosY, IKFeetPosXZ - (_cCoxaLength[LegIKLegNr]));
        IKA14 = getatan[0];

        //IKSW2 - Length between femur axis and tars
        IKSW2 = getatan[1];

        //IKA2 - Angle of the line S>W with respect to the femur in radians
        Temp1 = ((((_cFemurLength[LegIKLegNr])*(_cFemurLength[LegIKLegNr])) -
                ((_cTibiaLength[LegIKLegNr])*(_cTibiaLength[LegIKLegNr])))*C4Dec + (IKSW2*IKSW2));
        Temp2 = 2*(_cFemurLength[LegIKLegNr])*C2Dec*IKSW2;
        T3 = Temp1/(Temp2/C4Dec);
        IKA24 = GetArcCos(T3);
        //IKFemurAngle
        _femurAngle1[LegIKLegNr] = -(IKA14 + IKA24)*180/3141 + 900 + _cFemurHornOffset1[LegIKLegNr];

        //IKTibiaAngle
        Temp1 = ((((_cFemurLength[LegIKLegNr])*(_cFemurLength[LegIKLegNr])) +
                ((_cTibiaLength[LegIKLegNr])*(_cTibiaLength[LegIKLegNr])))*C4Dec - (IKSW2*IKSW2));
        Temp2 = (2*(_cFemurLength[LegIKLegNr])*(_cTibiaLength[LegIKLegNr]));

        _tibiaAngle1[LegIKLegNr] = -(900 - GetArcCos(Temp1 / Temp2) * 180 / 3141);

        //Set the Solution quality
        if (IKSW2 < ((_cFemurLength[LegIKLegNr]) + (_cTibiaLength[LegIKLegNr]) - 30)*C2Dec)
            _ikSolution = 1;
        else
        {
            if (IKSW2 < ((_cFemurLength[LegIKLegNr]) + (_cTibiaLength[LegIKLegNr]))*C2Dec)
                _ikSolutionWarning = 1;
            else
                _ikSolutionError = 1;
        }
    }

    void GaitSelect()
    {
        //Gait selector
        switch (GaitType)
        {
            case 0:
                //Ripple Gait 12 steps
                _gaitLegNr[CLr] = 1;
                _gaitLegNr[CRf] = 3;
                _gaitLegNr[CLm] = 5;
                _gaitLegNr[CRr] = 7;
                _gaitLegNr[CLf] = 9;
                _gaitLegNr[CRm] = 11;

                _nrLiftedPos = 3;
                _halfLiftHeight = 3;
                _tlDivFactor = 8;
                _stepsInGait = 12;
                _nomGaitSpeed = 70;
                break;
            case 1:
                //Tripod 8 steps
                _gaitLegNr[CLr] = 5;
                _gaitLegNr[CRf] = 1;
                _gaitLegNr[CLm] = 1;
                _gaitLegNr[CRr] = 1;
                _gaitLegNr[CLf] = 5;
                _gaitLegNr[CRm] = 5;

                _nrLiftedPos = 3;
                _halfLiftHeight = 3;
                _tlDivFactor = 4;
                _stepsInGait = 8;
                _nomGaitSpeed = 155;
                break;
            case 2:
                //Triple Tripod 12 step
                _gaitLegNr[CRf] = 3;
                _gaitLegNr[CLm] = 4;
                _gaitLegNr[CRr] = 5;
                _gaitLegNr[CLf] = 9;
                _gaitLegNr[CRm] = 10;
                _gaitLegNr[CLr] = 11;

                _nrLiftedPos = 3;
                _halfLiftHeight = 3;
                _tlDivFactor = 8;
                _stepsInGait = 12;
                _nomGaitSpeed = 60;
                break;
            case 3:
                // Triple Tripod 16 steps, use 5 lifted positions
                _gaitLegNr[CRf] = 4;
                _gaitLegNr[CLm] = 5;
                _gaitLegNr[CRr] = 6;
                _gaitLegNr[CLf] = 12;
                _gaitLegNr[CRm] = 13;
                _gaitLegNr[CLr] = 14;

                _nrLiftedPos = 5;
                _halfLiftHeight = 1;
                _tlDivFactor = 10;
                _stepsInGait = 16;
                _nomGaitSpeed = 60;
                break;
            case 4:
                //Wave 24 steps
                _gaitLegNr[CLr] = 1;
                _gaitLegNr[CRf] = 21;
                _gaitLegNr[CLm] = 5;

                _gaitLegNr[CRr] = 13;
                _gaitLegNr[CLf] = 9;
                _gaitLegNr[CRm] = 17;

                _nrLiftedPos = 3;
                _halfLiftHeight = 3;
                _tlDivFactor = 20;
                _stepsInGait = 24;
                _nomGaitSpeed = 70;
                break;
        }
    }

    static double Map(double x, double inMin, double inMax, double outMin, double outMax)
    {
        return (x - inMin) * (outMax - outMin) / (inMax - inMin) + outMin;
    }

    private void GaitSeq()
    {
        //Check if the Gait is in motion
        _travelRequest = ((Math.abs(TravelLengthX) > CTravelDeadZone) || (Math.abs(TravelLengthZ) > CTravelDeadZone) || (Math.abs(TravelRotationY) > CTravelDeadZone));

        if (_nrLiftedPos == 5)
            _liftDivFactor = 4;
        else
            _liftDivFactor = 2;

        //Calculate Gait sequence
        _lastLeg = 0;
        for (int _legIndex = 0; _legIndex <= 5; _legIndex++)
        {
            // for all legs
            if (_legIndex == 5) // last leg
                _lastLeg = 1;

            Gait(_legIndex);
        } // next leg
    }

    private void Gait(int GaitCurrentLegNr)
    {
        //Clear values under the cTravelDeadZone
        if (!_travelRequest)
        {
            TravelLengthX = 0;
            TravelLengthZ = 0;
            TravelRotationY = 0;
        }
        //Leg middle up position
        //Gait in motion
        //Gait NOT in motion, return to home position
        if ((_travelRequest && (_nrLiftedPos == 1 || _nrLiftedPos == 3 || _nrLiftedPos == 5) && _gaitStep == _gaitLegNr[GaitCurrentLegNr]) || (!_travelRequest && _gaitStep == _gaitLegNr[GaitCurrentLegNr] && ((Math.abs(_gaitPosX[GaitCurrentLegNr]) > 2) ||(Math.abs(_gaitPosZ[GaitCurrentLegNr]) > 2) || (Math.abs(_gaitRotY[GaitCurrentLegNr]) > 2))))
        {
            //Up
            _gaitPosX[GaitCurrentLegNr] = 0;
            _gaitPosY[GaitCurrentLegNr] = -LegLiftHeight;
            _gaitPosZ[GaitCurrentLegNr] = 0;
            _gaitRotY[GaitCurrentLegNr] = 0;
        }
        //Optional Half heigth Rear (2, 3, 5 lifted positions)
        else if (((_nrLiftedPos == 2 && _gaitStep == _gaitLegNr[GaitCurrentLegNr]) || (_nrLiftedPos >= 3 && (_gaitStep == _gaitLegNr[GaitCurrentLegNr] - 1 || _gaitStep == _gaitLegNr[GaitCurrentLegNr] + (_stepsInGait - 1)))) && _travelRequest)
        {
            _gaitPosX[GaitCurrentLegNr] = -TravelLengthX/_liftDivFactor;
            _gaitPosY[GaitCurrentLegNr] = -3*LegLiftHeight/(3 + _halfLiftHeight);
            //Easier to shift between div factor: /1 (3/3), /2 (3/6) and 3/4
            _gaitPosZ[GaitCurrentLegNr] = -TravelLengthZ/_liftDivFactor;
            _gaitRotY[GaitCurrentLegNr] = -TravelRotationY/_liftDivFactor;
        }

        // Optional Half heigth front (2, 3, 5 lifted positions)
        else if ((_nrLiftedPos >= 2) && (_gaitStep == _gaitLegNr[GaitCurrentLegNr] + 1 || _gaitStep == _gaitLegNr[GaitCurrentLegNr] - (_stepsInGait - 1)) && _travelRequest)
        {
            _gaitPosX[GaitCurrentLegNr] = TravelLengthX/_liftDivFactor;
            _gaitPosY[GaitCurrentLegNr] = -3*LegLiftHeight/(3 + _halfLiftHeight);
            // Easier to shift between div factor: /1 (3/3), /2 (3/6) and 3/4
            _gaitPosZ[GaitCurrentLegNr] = TravelLengthZ/_liftDivFactor;
            _gaitRotY[GaitCurrentLegNr] = TravelRotationY/_liftDivFactor;
        }

        //Optional Half heigth Rear 5 LiftedPos (5 lifted positions)
        else if (((_nrLiftedPos == 5 && (_gaitStep == _gaitLegNr[GaitCurrentLegNr] - 2))) && _travelRequest)
        {
            _gaitPosX[GaitCurrentLegNr] = -TravelLengthX/2;
            _gaitPosY[GaitCurrentLegNr] = -LegLiftHeight/2;
            _gaitPosZ[GaitCurrentLegNr] = -TravelLengthZ/2;
            _gaitRotY[GaitCurrentLegNr] = -TravelRotationY/2;
        }

        //Optional Half heigth Front 5 LiftedPos (5 lifted positions)
        else if ((_nrLiftedPos == 5) && (_gaitStep == _gaitLegNr[GaitCurrentLegNr] + 2 || _gaitStep == _gaitLegNr[GaitCurrentLegNr] - (_stepsInGait - 2)) && _travelRequest)
        {
            _gaitPosX[GaitCurrentLegNr] = TravelLengthX/2;
            _gaitPosY[GaitCurrentLegNr] = -LegLiftHeight/2;
            _gaitPosZ[GaitCurrentLegNr] = TravelLengthZ/2;
            _gaitRotY[GaitCurrentLegNr] = TravelRotationY/2;
        }

        //Leg front down position
        else if ((_gaitStep == _gaitLegNr[GaitCurrentLegNr] + _nrLiftedPos || _gaitStep == _gaitLegNr[GaitCurrentLegNr] - (_stepsInGait - _nrLiftedPos)) && _gaitPosY[GaitCurrentLegNr] < 0)
        {
            _gaitPosX[GaitCurrentLegNr] = TravelLengthX/2;
            _gaitPosZ[GaitCurrentLegNr] = TravelLengthZ/2;
            _gaitRotY[GaitCurrentLegNr] = TravelRotationY/2;
            _gaitPosY[GaitCurrentLegNr] = 0;
            //Only move leg down at once if terrain adaption is turned off
        }

        //Move body forward
        else
        {
            _gaitPosX[GaitCurrentLegNr] = _gaitPosX[GaitCurrentLegNr] - (TravelLengthX/_tlDivFactor);
            _gaitPosY[GaitCurrentLegNr] = 0;
            _gaitPosZ[GaitCurrentLegNr] = _gaitPosZ[GaitCurrentLegNr] - (TravelLengthZ/_tlDivFactor);
            _gaitRotY[GaitCurrentLegNr] = _gaitRotY[GaitCurrentLegNr] - (TravelRotationY/_tlDivFactor);
        }

        //Advance to the next step
        if (_lastLeg == 1)
        {
            //The last leg in this step
            _gaitStep = _gaitStep + 1;
            if (_gaitStep > _stepsInGait)
                _gaitStep = 1;
        }
    }

    private double[] GetSinCos(double angleDeg1)
    {
        double r[] = new double[2];
        double angle = Math.PI * angleDeg1 / 180.0;

        r[0] = Math.round(Math.sin(angle) * 10000);
        r[1] = Math.round(Math.cos(angle) * 10000);

        return r;
    }

    private double GetArcCos(double cos4)
    {
        boolean negativeValue /*:1*/; //If the the value is Negative

        double angleRad4 = 0;
        //Check for negative value
        if (cos4 < 0)
        {
            cos4 = -cos4;
            negativeValue = true;
        }
        else
            negativeValue = false;

        //Limit cos4 to his maximal value
        cos4 = Math.min(cos4, C4Dec);

        if ((cos4 >= 0) && (cos4 < 9000))
        {
            angleRad4 = (_getACos[(int)(cos4/79)]);
            angleRad4 = (angleRad4*616)/C1Dec; //616=acos resolution (pi/2/255) ;
        }
        else if ((cos4 >= 9000) && (cos4 < 9900))
        {
            angleRad4 = (_getACos[(int)((cos4 - 9000)/8 + 114)]);
            angleRad4 = angleRad4*616/C1Dec; //616=acos resolution (pi/2/255)
        }
        else if ((cos4 >= 9900) && (cos4 <= 10000))
        {
            angleRad4 = (_getACos[(int)((cos4 - 9900)/2 + 227)]);
            angleRad4 = angleRad4*616/C1Dec; //616=acos resolution (pi/2/255)
        }

        //Add negative sign
        if (negativeValue)
            angleRad4 = 31416 - angleRad4;

        return angleRad4;
    }

    private double[] GetATan2(double atanX, double atanY)
    {
        double atan4;
        double[] r = new double[2]; // 0 atan4, 1 xYhyp2

        r[1] = Math.sqrt((atanX * atanX * C4Dec) + (atanY * atanY * C4Dec)); //FIXED

        double angleRad4 = GetArcCos((atanX * C6Dec) / r[1]);

        if (atanY < 0) // removed overhead... Atan4 = AngleRad4 * (AtanY/abs(AtanY));
            r[0] = -angleRad4;
        else
            r[0] = angleRad4;

        return r;
    }

    private void CheckAngles()
    {
        for (int _legIndex = 0; _legIndex <= 5; _legIndex++)
        {
            _coxaAngle1[_legIndex] = Math.min(Math.max(_coxaAngle1[_legIndex], (_cCoxaMin1[_legIndex])), (_cCoxaMax1[_legIndex]));
            _femurAngle1[_legIndex] = Math.min(Math.max(_femurAngle1[_legIndex], (_cFemurMin1[_legIndex])), (_cFemurMax1[_legIndex]));
            _tibiaAngle1[_legIndex] = Math.min(Math.max(_tibiaAngle1[_legIndex], (_cTibiaMin1[_legIndex])), (_cTibiaMax1[_legIndex]));
        }
    }

    private void UpdateServoDriver()
    {
        String sscString = "";

        int _wCoxaSscv;
        int _wFemurSscv;
        int _wTibiaSscv;

        for (int _legIndex = 0; _legIndex <= 5; _legIndex++)
        {
            if (_legIndex < 3)
            {
                _wCoxaSscv = (int)Math.round(((-_coxaAngle1[_legIndex] + 900)*1000/CPwmDiv + CPfConst));
                _wFemurSscv = (int)Math.round(((-_femurAngle1[_legIndex] + 900)*1000/CPwmDiv + CPfConst));
                _wTibiaSscv = (int)Math.round(((-_tibiaAngle1[_legIndex] + 900)*1000/CPwmDiv + CPfConst));

                if (_legIndex == 0)
                {
                    sscString += "#7P" + _wCoxaSscv;
                    sscString += "#6P" + _wFemurSscv;
                    sscString += "#5P" + _wTibiaSscv;
                }
                if (_legIndex == 1)
                {
                    sscString += "#11P" + _wCoxaSscv;
                    sscString += "#10P" + _wFemurSscv;
                    sscString += "#9P" + _wTibiaSscv;
                }
                if (_legIndex == 2)
                {
                    sscString += "#15P" + _wCoxaSscv;
                    sscString += "#14P" + _wFemurSscv;
                    sscString += "#13P" + _wTibiaSscv;
                }
            }
            else
            {
                _wCoxaSscv = (int)Math.round(((_coxaAngle1[_legIndex] + 900)*1000/CPwmDiv + CPfConst));
                _wFemurSscv = (int)Math.round((((_femurAngle1[_legIndex] + 900)*1000/CPwmDiv + CPfConst)));
                _wTibiaSscv = (int)Math.round(((_tibiaAngle1[_legIndex] + 900)*1000/1059 + CPfConst));

                if (_legIndex == 5)
                {
                    sscString += "#23P" + _wCoxaSscv;
                    sscString += "#22P" + _wFemurSscv;
                    sscString += "#21P" + _wTibiaSscv;
                }
                if (_legIndex == 4)
                {
                    sscString += "#27P" + _wCoxaSscv;
                    sscString += "#26P" + _wFemurSscv;
                    sscString += "#25P" + _wTibiaSscv;
                }
                if (_legIndex == 3)
                {
                    sscString += "#31P" + _wCoxaSscv;
                    sscString += "#30P" + _wFemurSscv;
                    sscString += "#29P" + _wTibiaSscv;
                }
            }
        }

        sscString += "T" + (_nomGaitSpeed);

        Send(sscString);
    }

}


